// Copyright (C) 2019-2020 Zilliz. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance
// with the License. You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software distributed under the License
// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing permissions and limitations under the License.

#include "scheduler/selector/Optimizer.h"

namespace milvus {
namespace scheduler {

void
Optimizer::Init() {
    for (auto& pass : pass_list_) {
        pass->Init();
    }
}

bool
Optimizer::Run(const TaskPtr& task) {
    for (auto& pass : pass_list_) {
        if (pass->Run(task)) {
            return true;
        }
    }

    return false;
}

void
Optimizer::Stop() {
    pass_list_ = std::vector<PassPtr>();
}

}  // namespace scheduler
}  // namespace milvus
